package service

import (
	"encoding/xml"

	"gitee.com/yansen_zh/wechat-oplatform-sdk/utils/encrypt"
)

// ComponentVerifyTicketResult 获取验证票据结果
type ComponentVerifyTicketResult struct {
	AppId                 string  `xml:"AppId"`
	CreateTime            float64 `xml:"CreateTime"`
	InfoType              string  `xml:"InfoType"`
	ComponentVerifyTicket string  `xml:"ComponentVerifyTicket"`
}

// ComponentVerifyTicket 获取验证票据
func VerifyTicket(data []byte, encodingAESKey, iv string) (*ComponentVerifyTicketResult, error) {
	bt, err := encrypt.MsgDecode(data, encodingAESKey, iv)
	if nil != err {
		return nil, err
	}

	res := ComponentVerifyTicketResult{}

	if e := xml.Unmarshal(bt, &res); e != nil {
		return nil, e
	}

	return &res, nil
}
